﻿/**
http://BenSilvis.com
You may reuse this code as you please.
*/
		
package
{	
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	public class KeyCodes extends Sprite
	{
		public function KeyCodes()
		{			
			stage.addEventListener(KeyboardEvent.KEY_UP, onKeyEvent);
		}
		
		/**
		Called after every Keyboard Key Up. Verifies against certain character types, then
		creates and formats a new text field before adding it to the stage.
		*/
		private function onKeyEvent(e:KeyboardEvent):void
		{		
			keyCode_txt.text = String(e.keyCode);
									//Excludes:
			if (e.charCode != 0 &&  //non character Keys (Shift, Ctrl, Alt, Home, etc.)
				e.charCode != 13 &&	//Enter Keys
				e.charCode != 46 && //Delete
				e.charCode != 8 && 	//Backspace
				e.charCode != 27 && //Esc
				e.charCode != 32 && //Space
				e.charCode != 9) 	//& Tab
			{
				var charPopFormat:TextFormat = new TextFormat(); //Creates and sets some attributes of a new TextFormat
				charPopFormat.color = 0xFFFFFF;
				charPopFormat.size = RandomNumber(16, 145); //Sets the format to a random text size
				charPopFormat.bold = true;
				
				var character:String = String.fromCharCode(e.charCode); //Creates a new String of the pressed key's character
				
				var charPop:TextField = new TextField(); //Instantiate a new TextField
				charPop.htmlText = character; 			 //Adds 'character' to the TextField
				charPop.selectable = false;
				charPop.autoSize = TextFieldAutoSize.LEFT;
				charPop.setTextFormat(charPopFormat); 	//Formats the TextField with 'charPopFormat'
				addChildAt(charPop, 1);
				charPop.x = RandomNumber(0, stage.stageWidth) - (charPop.textWidth / 2); //Positions the TextField randomly on the stage
				charPop.y = RandomNumber(0, stage.stageHeight) - (charPop.textHeight / 2);
			}
		}
		
		/**
		Returns a random number inbetween the input low and high numbers
		*/
		private function RandomNumber(low:int, high:int):int 
		{
			var randomUnrounded:Number = Math.random() * (high - low);
			var randomNumber:int = Math.round(randomUnrounded); 
			randomNumber += low; 
			
			return randomNumber;
		}
	}
}